#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define N		10				/* N */
#define EPS		pow(10.0, -8.0)	/* epsilon̐ݒ */
#define KMAX	100

/* s̓ */
void input_matrix(double **a, char c, FILE* fin, FILE* fout);
/* xNg̓ */
void input_vector(double *b, char c, FILE* fin, FILE* fout);
/* s̗̈m */
double **dmatrix(int nr1, int nr2, int nl1, int nl2);
/* s̗̈@ */
void free_dmatrix(double** a, int nr1, int nr2, int nl1, int nl2);
/* xNg̈̊m */
double* dvector(int i, int j);
/* xNg̗̈@ */
void free_dvector(double* a, int i);
/* 1m̌vZ */
double vector_norm1(double* a, int m, int n);
/* AxNg a[m...n]b[m...n]̓ςvZ */
double inner_product(int m, int n, double* a, double* b);
/* sa[1...N][1...]ƃxNgb[1...N]Ƃ̐ c <- Ab */
void matrix_vector_product(double** a, double* b, double* c);

double* cg(double** a, double* b, double* x);

/* s̓ */
void input_matrix(double **a, char c, FILE* fin, FILE* fout) {
	int i, j;
	fprintf(fout, "s%c͎̒ʂł\n", c);
	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= N; ++j) {
			fscanf(fin, "%lf", &(a[i][j]));
			fprintf(fout, "%5.2f\t", a[i][j]);
		}
		fprintf(fout, "\n");
	}
}

/* xNg̓ */
void input_vector(double *b, char c, FILE* fin, FILE* fout) {
	int i;
	fprintf(fout, "xNg%c͎̒ʂł\n", c);
	for (i = 1; i <= N; ++i) {
		fscanf(fin, "%lf", &(b[i]));
		fprintf(fout, "%5.2f\t", b[i]);
		fprintf(fout, "\n");
	}
}

/* s̗̈m */
double** dmatrix(int nr1, int nr2, int nl1, int nl2)
{
	int i, nrow, ncol;
	double** a;

	nrow = nr2 - nr1 + 1; /* s̐ */
	ncol = nl2 - nl1 + 1; /* ̐ */

	/* s̊m */
	if ((a = malloc(nrow * sizeof(double*))) == NULL)
	{
		printf("mۂł܂isaj\n");
		exit(1);
	}
	a = a - nr1; /* s炷 */

	/* ̊m */
	for (i = nr1; i <= nr2; ++i) a[i] = malloc(ncol * sizeof(double)); 
	/* for (i = 0; i < nrow; ++i) a[i] = malloc(ncol * sizeof(double)); */
	for (i = nr1; i <= nr2; i++) a[i] = a[i] - nl1; 

	return a;
}

/* s̗̈@ */
void free_dmatrix(double** a, int nr1, int nr2, int nl1, int nl2) 
{
	int i;

	/* ̉@@*/
	for (i = nr1; i <= nr2; ++i) free((void*)(a[i] + nl1)); 
	free((void*)(a + nr1)); 
}

/* xNg̈̊m */
double* dvector(int i, int j) /* a[i]`a[j]̗̈m */
{
	double* a;

	if ((a = malloc(((j - i + 1) * sizeof(double)))) == NULL)
	{
		printf("mۂł܂ifrom dvectorj\n");
		exit(1);
	}

	return(a - i);
}

/* xNg̗̈@ */
void free_dvector(double* a, int i)
{
	free((void*)(a + i)); /* (void *)^ւ̃LXgKv@*/
}

/* 1m̌vZ */
double vector_norm1(double* a, int m, int n)
{
	int i;
	double norm = 0.0;
	for (i = m; i <= n; i++)
	{
		norm += fabs(a[i]);
	}
	return norm;
}

/* AxNg a[m...n]b[m...n]̓ςvZ */
double inner_product(int m, int n, double* a, double* b)
{
	int i;
	double s = 0.0;

	for (i = m; i <= n; i++) s += a[i] * b[i];

	return s;
}

int main(void)
{
	FILE* fin, * fout;
	double** a, * b, * x;
	int i;

	/* s񂨂уxNg̗̈m */
	a = dmatrix(1, N, 1, N); /* s a[l. . .N] [1. . .N] */
	b = dvector(1, N); /* b[l...N] */
	x = dvector(1, N); /* x[l...N] */

	/* t@C̃I[v */

	if ((fin = fopen("input_sp.dat", "r")) == NULL)
	{
		printf("t@C܂ : input_sp.dat \n");
		exit(1);
	}
	if ((fout = fopen("output_sp.dat", "w")) == NULL)
	{
		printf("t@C쐬ł܂ : output_sp.dat \n");
		exit(1);
	}

	input_matrix(a, 'A', fin, fout); /* sA̓o */
	input_vector(b, 'b', fin, fout); /* xNgb̓o */
	input_vector(x, 'x', fin, fout); /* xNgx0̓o */
	x = cg(a, b, x);

	/* ʂ̏o */
	fprintf(fout, "Ax=b ͎̉̒ʂł\n");
	for (i = 1; i <= N; i++)
	{
		fprintf(fout, "%f\n", x[i]);
	}

	fclose(fin); fclose(fout); /* t@C̃N[Y */

	/* ̈̉@ */
	free_dmatrix(a, 1, N, 1, N); free_dvector(b, 1); free_dvector(x, 1);

	return 0;
}

/* z@ */
double* cg(double** a, double* b, double* x)
{
	double eps, * r, * p, * tmp, alpha, beta, work;
	int i, k = 0;
	r = dvector(1, N); /* r[l...N] */
	p = dvector(1, N); /* p[l...N] */
	tmp = dvector(1, N); /* tmp[l...N] */

	matrix_vector_product(a, x, tmp); /* tmp <- A b */

	for( i = 1; i <= N; i++)
	{
		p[i] = b[i] - tmp[i]; r[i] = p[i];
	}

	do
	{
		/* alpha ̌vZ */
		matrix_vector_product(a, p, tmp); /* tmp <- A p_k */
		work = inner_product(1, N, p, tmp); /* work <- (p,Ap_k) */
		alpha = inner_product(1, N, p, r) / work;

		/* x_{k+l}  r_{k+l}̌vZ */
		for (i = 1; i <= N; i++) x[i] = x[i] + alpha * p[i];
		for (i = 1; i <= N; i++) r[i] = r[i] - alpha * tmp[i];

		/*  */
		eps = vector_norm1(r, 1, N);
		k++; /* 񐔂̍XV */
		if (eps < EPS) goto OUTPUT;

		/* beta  p_{k+l}̌vZ */
		beta = -inner_product(1, N, r, tmp) / work;
		for (i = 1; i <= N; i++) p[i] = r[i] + beta * p[i];
	}while (k < KMAX);

OUTPUT:;
	/* ̈̉ */
	free_dvector(r, 1); free_dvector(p, 1); free_dvector(tmp, 1);
	if (k == KMAX)
	{
		printf("܂ł\n");
		exit(1);
	}
	else
	{
		printf("񐔂%dł\n", k); /* 񐔂ʂɕ\ */
		return x;
	}
}

/* sa[1...N][1...]ƃxNgb[1...N]Ƃ̐ c <- Ab */
void matrix_vector_product(double** a, double* b, double* c)
{
	double wk;
	int i, j;
	for (i = 1; i <= N; i++)
	{
		wk = 0.0;
		for (j = 1; j <= N; j++)
		{
			wk += a[i][j] * b[j];
		}
		c[i] = wk;
	}
}

